const CommandBase = require('../command.base');
const TestController = require('./test.controller');


//TODO: Resolve more correct issue with lost context
const command = new CommandBase({
    command: 'test',
    handler: TestController.runTests.bind(TestController),
    desc: 'Run cucumber tests',
    builder(yargs) {
        return yargs
            .option('admin-token', {
                describe: 'api admin key, provide, if you want to run tests as new user',
                type: 'string',
            })
            .option('tests-source', {
                describe: 'path of dir holds features files and steps',
                type: 'string',
                required: true
            })
            .option('user-token', {
                describe: 'provide, if tests will run via created user',
                type: 'string',
            })
            .option('context', {
                default: false,
                describe: 'use token and endpoint from context',
                type: 'boolean',
            })
            .option('api-url', {
                default: 'http://local.codefresh.io',
                describe: 'api url',
                type: 'string',
            })
            .option('tag', {
                default: [],
                describe: 'needed tags for test',
                type: 'array',

            })
            .option('report', {
                describe: 'generate \'allure\' or \'html\' report',
                type: 'string',
            })
            .option('coverage', {
                default: false,
                describe: 'display coverage info',
                type: 'boolean',
            })
            .option('report-server', {
                default: false,
                describe: 'start report server for preview allure',
                type: 'boolean',
            })
            .option('report-path', {
                default: '.',
                describe: 'path for allure output',
                type: 'string',
            })
            .option('port', {
                describe: 'port of report server',
                type: 'number',
                default: 4000,
            });
    },
});

module.exports = command;
