class Config {
    // path to dir which will contains steps definitions
    #stepsPath = './steps';

    // will be initialized on start

    // absolute path to source dir where exists features and step definitions
    #sourceTestsPath = '';

    // absolute path to source dir with steps definitions from where steps will moved to <stepsPath>
    #sourceStepsPath= '';

    // absolute path to source dir with features
    #sourceFeaturesExistsUserPath= '';
    #sourceFeaturesNewUserPath= '';

    #reportPath = '.';


    init({ argv }) {
        let source = argv['tests-source'];
        source = source.endsWith('/') ? source : source + '/';

        this.#sourceTestsPath = source;
        this.#sourceStepsPath = `${source}steps`;
        this.#sourceFeaturesExistsUserPath = `${source}features-exist-user`;
        this.#sourceFeaturesNewUserPath = `${source}features-new-user`;
    }

    getStepsPath() {
        return this.#stepsPath;
    }

    getSourceStepsPath() {
        return this.#sourceStepsPath;
    }

    getSourceFeaturesExistsUserPath() {
        return this.#sourceFeaturesExistsUserPath;
    }

    getSourceFeaturesNewUserPath() {
        return this.#sourceFeaturesNewUserPath;
    }

    setReportPath(path) {
        this.#reportPath = path;
    }

    getReportPath() {
        return this.#reportPath;
    }
}

module.exports = new Config();